package ca.thetechrobo.rltime;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import org.bukkit.NamespacedKey;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;
import org.bukkit.plugin.java.JavaPlugin;
import org.jetbrains.annotations.NotNull;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.TextComponent;
import net.kyori.adventure.text.format.TextColor;

public class GetTime implements CommandExecutor {

	private JavaPlugin pl;

	@Override
	public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label,
			@NotNull String[] args) {

		SimpleDateFormat format = new SimpleDateFormat("HH:mm:ss z");
		if (sender instanceof Player) {
			Player p = (Player) sender;
			PersistentDataContainer c = p.getPersistentDataContainer();
			NamespacedKey key = new NamespacedKey(this.pl, "24HourTime");
			if (c.has(key, PersistentDataType.STRING) && c.get(key, PersistentDataType.STRING).equals("false")) {
				format = new SimpleDateFormat("h:mm:ss a z");
			}
		}
		Date now = Calendar.getInstance().getTime();
		TextComponent time = Component.text(format.format(now)).color(TextColor.color(255, 0, 255));
		sender.sendMessage(Component.text("I think it's ").color(TextColor.color(64, 254, 127)).append(time));
		return true;
	}

	public GetTime(JavaPlugin pl) {
		this.pl = pl;
	}

}
